SystemOrganization addCategory: #'Twitter-Bootstrap-Examples-Magritte'!

GRObject subclass: #TWBSMagritteFormChooser
	instanceVariableNames: 'layoutStyle validationMessageStyle'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Twitter-Bootstrap-Examples-Magritte'!

!TWBSMagritteFormChooser methodsFor: 'magritte descriptions' stamp: 'NickAger 3/19/2012 17:05'!
descriptionContainer
	<magritteContainer>
	^ super descriptionContainer
		componentRenderer: TWBSMagritteFormRenderer;
		yourself! !

!TWBSMagritteFormChooser methodsFor: 'accessing' stamp: 'NickAger 3/22/2012 11:03'!
isLayoutStyleFormInline
	^ self layoutStyle = 'form-inline'! !

!TWBSMagritteFormChooser methodsFor: 'accessing' stamp: 'NickAger 3/20/2012 13:47'!
isValidationMessageStyleBoth
	^ self validationMessageStyle = 'Inline and top validation messages'! !

!TWBSMagritteFormChooser methodsFor: 'accessing' stamp: 'NickAger 3/20/2012 13:47'!
isValidationMessageStyleInline
	^ self isValidationMessageStyleTop not or: [ self isValidationMessageStyleBoth ]! !

!TWBSMagritteFormChooser methodsFor: 'accessing' stamp: 'NickAger 3/20/2012 13:47'!
isValidationMessageStyleTop
	^ self validationMessageStyle = 'top validation messages' or: [ self isValidationMessageStyleBoth ]! !

!TWBSMagritteFormChooser methodsFor: 'accessing' stamp: 'NickAger 3/19/2012 17:28'!
layoutStyle
	^ layoutStyle ifNil: [ layoutStyle := self layoutStyles first ]! !

!TWBSMagritteFormChooser methodsFor: 'accessing' stamp: 'NickAger 3/19/2012 16:34'!
layoutStyle: anObject
	layoutStyle := anObject! !

!TWBSMagritteFormChooser methodsFor: 'magritte descriptions' stamp: 'NickAger 3/21/2012 20:50'!
layoutStyleDescription
	<magritteDescription>
	^ MASingleOptionDescription new 
		label: 'Layout styles';
		accessor: #layoutStyle;
		options: self layoutStyles;
		comment: 'choose a layout style';
		componentClass: TWBSMagritteRadioGroupComponent;
		beRequired;
		yourself! !

!TWBSMagritteFormChooser methodsFor: 'options' stamp: 'NickAger 3/19/2012 16:31'!
layoutStyles
	^ Array with: 'form-vertical' with: 'form-inline' with: 'form-search' with: 'form-horizontal'! !

!TWBSMagritteFormChooser methodsFor: 'printing' stamp: 'NickAger 3/21/2012 18:09'!
optionsSelectedString
	^ layoutStyle, ', ', validationMessageStyle! !

!TWBSMagritteFormChooser methodsFor: 'accessing' stamp: 'NickAger 3/20/2012 13:28'!
validationMessageStyle
	^ validationMessageStyle ifNil: [ validationMessageStyle := self validationMessageStyles first ]! !

!TWBSMagritteFormChooser methodsFor: 'accessing' stamp: 'NickAger 3/20/2012 13:28'!
validationMessageStyle: anObject
	validationMessageStyle := anObject! !

!TWBSMagritteFormChooser methodsFor: 'magritte descriptions' stamp: 'NickAger 3/20/2012 18:12'!
validationMessageStyleDescription
	<magritteDescription>
	^ MASingleOptionDescription new 
		label: 'Error message styles';
		accessor: #validationMessageStyle;
		options: self validationMessageStyles;
		comment: 'choose an error message style';
		componentClass: MASelectListRowsComponent;
		beRequired;
		yourself! !

!TWBSMagritteFormChooser methodsFor: 'options' stamp: 'NickAger 3/20/2012 13:46'!
validationMessageStyles
	^ Array with: 'inline validation messages' with: 'top validation messages' with: 'Inline and top validation messages'! !

WATask subclass: #TWBSMagritteExampleTask
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Twitter-Bootstrap-Examples-Magritte'!

!TWBSMagritteExampleTask methodsFor: 'private' stamp: 'NickAger 3/22/2012 11:51'!
createFormBasedOn: formChooser
	| theForm |
	theForm := TWBSMagritteFormExample new asComponent.
	
	formChooser isValidationMessageStyleTop ifTrue: [
		theForm addDecoration: TWBSMagritteValidationDecoration new ].
	
	theForm
		addDecoration: 
			(TWBSMagritteFormDecoration newWithDefaultButtons 
				formCss: formChooser layoutStyle;
				legend: formChooser optionsSelectedString;
				yourself);
		yourself.
	
	theForm magritteDescription twbsInlineValidationMessages: formChooser isValidationMessageStyleInline.
	formChooser isLayoutStyleFormInline ifTrue: [
		theForm magritteDescription twbsFormInline: true.
		"inline styles look better without comments"
		theForm magritteDescription do: [ :aDescription |
			aDescription comment: nil ] ].
	
	^ theForm! !

!TWBSMagritteExampleTask methodsFor: 'private' stamp: 'NickAger 3/22/2012 11:51'!
formChooser
	^ (TWBSMagritteFormChooser new asComponent)
		addDecoration: (TWBSMagritteFormDecoration buttons: (Array with: #save -> 'Create a new form'));
		yourself! !

!TWBSMagritteExampleTask methodsFor: 'running' stamp: 'NickAger 3/22/2012 11:56'!
go
	[ 
	| chosenForm formChooser chosenFormAnswer |
	formChooser := self call: self formChooser.
	chosenForm := (self createFormBasedOn: formChooser).
	
	chosenFormAnswer := self call: chosenForm.
	chosenFormAnswer notNil
		ifTrue: [ self twbsInformSuccess: [ :r | r strong: 'Well done'; text: ' you have managed to survive our arbitary validation.' ] ]
		ifFalse: [ self twbsInformError: [ :r | r strong: 'Cancelled'; text: ' Oh well you can always try again to see if you can work-through our arbitary validation.' ] ]
	 ] repeat! !

WAComponent subclass: #TWBSMagritteExample
	instanceVariableNames: 'task'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Twitter-Bootstrap-Examples-Magritte'!

!TWBSMagritteExample class methodsFor: 'initialization' stamp: 'NickAger 3/20/2012 13:57'!
initialize
	| application |
	application := WAAdmin register: self asApplicationAt: 'magritte-twitter-bootstrap-example'.
	application preferenceAt: #scriptGeneratorClass put: JQScriptGenerator	! !

!TWBSMagritteExample methodsFor: 'hooks' stamp: 'NickAger 3/22/2012 11:54'!
children
	^ Array with: self task! !

!TWBSMagritteExample methodsFor: 'rendering' stamp: 'NickAger 3/22/2012 11:50'!
renderContentOn: html
	html twbsContainer: [
		html twbsRow: [
			html heading level1; with: [
				html text: 'Twitter Bootstrap '; small: 'Magritte Form rendering example' ] ].
		
		html twbsRow: [
			html twbsSpan: 7 with: self task ].
		
		html twbsRow: [
			html twbsSpan: 7 with: [
				html text: 'For more information see the '.
				html anchor url: 'http://twitter.github.com/bootstrap/'; with: 'Twitter Bootstrap documentation' ] ] ]
! !

!TWBSMagritteExample methodsFor: 'accessing' stamp: 'NickAger 3/22/2012 11:50'!
task
	^ task ifNil: [ task := TWBSMagritteExampleTask new ]! !

!TWBSMagritteExample methodsFor: 'updating' stamp: 'NickAger 3/22/2012 11:45'!
updateRoot: anHtmlRoot
	super updateRoot: anHtmlRoot.
	
	JQDevelopmentLibrary default updateRoot: anHtmlRoot.
	TWBSDevelopmentLibrary default updateRoot: anHtmlRoot.! !

WAComponent subclass: #TWBSMagritteFormExample
	instanceVariableNames: 'name number bePositive'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Twitter-Bootstrap-Examples-Magritte'!

!TWBSMagritteFormExample methodsFor: 'accessing' stamp: 'NickAger 3/22/2012 11:22'!
bePositive
	^ bePositive ifNil: [ bePositive := true ]! !

!TWBSMagritteFormExample methodsFor: 'accessing' stamp: 'NickAger 3/22/2012 11:21'!
bePositive: anObject
	bePositive := anObject! !

!TWBSMagritteFormExample methodsFor: 'magritte descriptions' stamp: 'NickAger 3/22/2012 12:36'!
bePositiveDescription
	<magritteDescription>
	^ MABooleanDescription new
		checkboxLabel: 'Be positive';
		accessor: #bePositive;
		componentClass: TWBSMagritteCheckboxComponent;
		priority: 600;
		yourself! !

!TWBSMagritteFormExample methodsFor: 'magritte descriptions' stamp: 'NickAger 3/19/2012 16:48'!
descriptionContainer
	<magritteContainer>
	^ super descriptionContainer
		componentRenderer: TWBSMagritteFormRenderer;
		yourself! !

!TWBSMagritteFormExample methodsFor: 'accessing' stamp: 'NickAger 3/19/2012 16:48'!
name
	^ name
! !

!TWBSMagritteFormExample methodsFor: 'accessing' stamp: 'NickAger 3/19/2012 16:48'!
name: anObject
	name := anObject! !

!TWBSMagritteFormExample methodsFor: 'magritte descriptions' stamp: 'NickAger 3/21/2012 20:51'!
nameDescription
	<magritteDescription>
	^ MAStringDescription new
		priority: 10;
		label: 'Name';
		accessor: #name;
		beRequired;
		requiredErrorMessage: 'We cannot proceed without a name.';
		comment: 'Please enter your name';
		componentClass: TWBSMagritteTextInputComponent; "is required for placeholder text below"
		placeholder: 'your name';
		yourself! !

!TWBSMagritteFormExample methodsFor: 'accessing' stamp: 'NickAger 3/19/2012 16:56'!
number
	^ number! !

!TWBSMagritteFormExample methodsFor: 'accessing' stamp: 'NickAger 3/19/2012 16:56'!
number: anObject
	number := anObject! !

!TWBSMagritteFormExample methodsFor: 'magritte descriptions' stamp: 'NickAger 3/20/2012 13:52'!
numberDescription
	<magritteDescription>
	^ MASingleOptionDescription new
		priority: 30;
		label: 'Numbers';
		accessor: #number;
		options: (0 to: 10);
		comment: 'select your favourite number';
		addCondition: [ :v | v ~= 0 ] labelled: 'sorry we are not permitting zero to be favourite';
		addCondition: [ :v | v ~= 1 ] labelled: 'sorry we are not permitting one to be favourite';
		beRequired;
		yourself! !
TWBSMagritteExample initialize!
